// Landscape by Jumpjack 2006
//
// Activate screen landscape modes on Motorola a1000.
// The only program which can take advantage of landscape
// mode is the preinstalled Opera 7.50.

// To enable the dynamic loading of the menu with a Close command in the UDEB version
#include <eikmenub.h>
#include <apgtask.h> // For TApaTaskList. Add apgrfx.lib in .MMP file.
#include <apgcli.h> // For RApaLsSession. Add apgrfx.lib in .MMP file.
#include "Landscape.h"
//             The second phase constructor of the application UI class.
//             The application UI creates and owns the one and only view.
// 
void CExampleAppUi::ConstructL()
    {
	           // BaseConstructL() completes the UI framework's
	           // construction of the App UI.
    BaseConstructL();
     
    
	           // Create the single application view in which to
	           // draw the information text, passing into it
	           // the rectangle available to it.
	iAppView = CExampleAppView::NewL(ClientRect());

	iText=iEikonEnv->AllocReadResourceL(R_EXAMPLE_TEXT_BOPPI); // Url to open.
  CExampleAppUi::OpenUrl2(*iText); // Launch browser 
	CWsScreenDevice  *DeviceMap = iEikonEnv->ScreenDevice(); // Used to rotate the screen.
	DeviceMap->SetScreenMode(2); // Activate mode 2 (270 or -90 degrees)
	iText=iEikonEnv->AllocReadResourceL(R_EXAMPLE_TEXT_BOPPI); // Url to open.
  CExampleAppUi::OpenUrl2(*iText); // Launch browser 
	Exit();
	}


//             The app Ui owns the two views and is. 
//             therefore, responsible for destroying them
//
CExampleAppUi::~CExampleAppUi()
	{
	delete iAppView;
	}


//             Called by the UI framework when a command has been issued.
//             In this example, a command can originate through a 
//             hot-key press or by selection of a menu item.
//             The command Ids are defined in the .hrh file
//             and are 'connected' to the hot-key and menu item in the
//             resource file.
//             Note that the EEikCmdExit is defined by the UI
//             framework and is pulled in by including eikon.hrh
//


void CExampleAppUi::HandleCommandL(TInt aCommand)
	{
	CWsScreenDevice  *DeviceMap = iEikonEnv->ScreenDevice(); // Used to rotate the screen.
//	iText=iEikonEnv->AllocReadResourceL(R_EXAMPLE_TEXT_BOPPI); // Url to open.
          

	switch (aCommand)
		{
		      // Just issue simple info messages to show that
		      // the menu items have been selected
	case EExampleItem0:
		iEikonEnv->InfoMsg(R_EXAMPLE_TEXT_ITEM0); 
		DeviceMap->SetScreenMode(0); // Normal mode
		break;

	
	case EExampleItem1:
		iEikonEnv->InfoMsg(R_EXAMPLE_TEXT_ITEM1); 
		DeviceMap->SetScreenMode(2); // Activate mode 2 (270 or -90 degrees)
//		Exit();
		
		break;
	
           // Exit the application. The call is
		       // implemented by the UI framework.
	case EEikCmdExit: 
		Exit();
		break;
		}
	}


// This is a way to dynamically initialize the menu.
// If it is the debug version, the menu should contain a Close command.
// In the release version, there should be no Close command.
//#if defined(_DEBUG)
void CExampleAppUi::DynInitMenuPaneL(TInt aMenuId, CEikMenuPane* aMenuPane)
	{
	if(aMenuId == R_EXAMPLE_FIRST_MENU)
		{
		CEikMenuPaneItem::SData itemData;
		TBuf<16> closeCommandText;
		iEikonEnv->ReadResource(closeCommandText, R_EXAMPLE_CLOSE_COMMAND);
		itemData.iText=closeCommandText;
		itemData.iCommandId=EEikCmdExit;
		itemData.iFlags=0;
		itemData.iCascadeId=0;
		aMenuPane->AddMenuItemL(itemData);
		}
	}
//#endif

void CExampleAppUi::OpenUrl2(const TDesC& iUrl)
{
	HBufC* param = HBufC::NewLC( 128 );
	param->Des().Copy(iUrl);
	
	//Browser's constants UId
	const TInt KWmlBrowserUid = 0x100051e6;
	
	TUid id( TUid::Uid( KWmlBrowserUid ) );
	TApaTaskList taskList( CEikonEnv::Static()->WsSession() );
	TApaTask task = taskList.FindApp( id );
	
	if ( task.Exists() )
		{
		task.BringToForeground();
		task.SwitchOpenFile(*param);
		}
	else
		{
		RApaLsSession appArcSession;
		User::LeaveIfError(appArcSession.Connect()); // connect to AppArc server
		TThreadId id;
		appArcSession.StartDocument( *param, TUid::Uid( KWmlBrowserUid ), id );
		appArcSession.Close();
		}
	CleanupStack::PopAndDestroy(); // param
	}

